## colobot 0.1.8

=== CMakeLists.txt ===
##
# Main CMake project file
# Contains global options and definitions
##

cmake_minimum_required(VERSION 2.8)

project(colobot C CXX)

##
# Project version
##
set(COLOBOT_VERSION_CODENAME "Gold")
set(COLOBOT_VERSION_MAJOR    0)
set(COLOBOT_VERSION_MINOR    1)
set(COLOBOT_VERSION_REVISION 8)

# Used on official releases
set(COLOBOT_VERSION_RELEASE_CODENAME "-alpha")
# Used on unreleased, development builds
#set(COLOBOT_VERSION_UNRELEASED "+alpha")

# Append git characteristics to version
if(DEFINED COLOBOT_VERSION_UNRELEASED)
    if(EXISTS "${CMAKE_SOURCE_DIR}/.git")
        find_package(Git)
        execute_process(COMMAND ${GIT_EXECUTABLE} rev-parse --abbrev-ref HEAD
                        WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
                        OUTPUT_VARIABLE GIT_BRANCH
                        OUTPUT_STRIP_TRAILING_WHITESPACE)
        execute_process(COMMAND ${GIT_EXECUTABLE} rev-parse --short HEAD
                        WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
                        OUTPUT_VARIABLE GIT_REVISION
                        OUTPUT_STRIP_TRAILING_WHITESPACE)
        set(COLOBOT_VERSION_UNRELEASED "${COLOBOT_VERSION_UNRELEASED}-git-${GIT_BRANCH}~r${GIT_REVISION}")
        set(COLOBOT_VERSION_DISPLAY "git-${GIT_BRANCH}~r${GIT_REVISION}")
    else()
        set(COLOBOT_VERSION_DISPLAY "${COLOBOT_VERSION_CODENAME}-${COLOBOT_VERSION_UNRELEASED}")
    endif()
else()
    set(COLOBOT_VERSION_DISPLAY "${COLOBOT_VERSION_MAJOR}.${COLOBOT_VERSION_MINOR}.${COLOBOT_VERSION_REVISION}${COLOBOT_VERSION_RELEASE_CODENAME}")
endif()

set(COLOBOT_VERSION_FULL "${COLOBOT_VERSION_MAJOR}.${COLOBOT_VERSION_MINOR}.${COLOBOT_VERSION_REVISION}${COLOBOT_VERSION_UNRELEASED}${COLOBOT_VERSION_RELEASE_CODENAME}")
message(STATUS "Building Colobot \"${COLOBOT_VERSION_CODENAME}\" (${COLOBOT_VERSION_FULL})")

set(BUILD_NUMBER 0)
if(NOT "$ENV{BUILD_NUMBER}" STREQUAL "")
    set(BUILD_NUMBER "$ENV{BUILD_NUMBER}")
    message(STATUS "CI build #${BUILD_NUMBER}")
endif()


##
# Platform detection and some related checks
##
if("${CMAKE_SYSTEM_NAME}" MATCHES "Windows")
    message(STATUS "Build for Windows system")
    set(PLATFORM_WINDOWS 1)
    set(PLATFORM_GNU     0)
    set(PLATFORM_LINUX   0)
    set(PLATFORM_MACOSX  0)
    set(PLATFORM_OTHER   0)

    # Platform-dependent implementation of system.h
    set(SYSTEM_CPP_MODULE "system_windows.cpp")
    set(SYSTEM_H_MODULE "system_windows.h")
elseif("${CMAKE_SYSTEM_NAME}" MATCHES "Linux")
    message(STATUS "Build for Linux system")
    set(PLATFORM_WINDOWS 0)
    set(PLATFORM_LINUX   1)
    set(PLATFORM_GNU     1)
    set(PLATFORM_MACOSX  0)
    set(PLATFORM_OTHER   0)

    # Platform-dependent implementation of system.h
    set(SYSTEM_CPP_MODULE "system_linux.cpp")
    set(SYSTEM_H_MODULE "system_linux.h")
elseif("${CMAKE_SYSTEM_NAME}" MATCHES "kFreeBSD" OR "${CMAKE_SYSTEM_NAME}" STREQUAL "GNU")
    message(STATUS "Build for kFreeBSD system")
    set(PLATFORM_WINDOWS 0)
    set(PLATFORM_LINUX   0)
    set(PLATFORM_GNU     1)
    set(PLATFORM_MACOSX  0)
    set(PLATFORM_OTHER   0)

    # Platform-dependent implementation of system.h
    set(SYSTEM_CPP_MODULE "system_other.cpp")
    set(SYSTEM_H_MODULE "system_other.h")
elseif("${CMAKE_SYSTEM_NAME}" MATCHES "Darwin")
    message(STATUS "Build for Mac OSX system")
    set(PLATFORM_WINDOWS 0)
    set(PLATFORM_LINUX   0)
    set(PLATFORM_GNU     0)
    set(PLATFORM_MACOSX  1)
    set(PLATFORM_OTHER   0)

    # Platform-dependent implementation of system.h
    set(SYSTEM_CPP_MODULE "system_macosx.cpp")
    set(SYSTEM_H_MODULE "system_macosx.h")
    # To avoid CMake warning
    set(CMAKE_MACOSX_RPATH 1)
else()
    message(STATUS "Build for other system")
    set(PLATFORM_WINDOWS 0)
    set(PLATFORM_LINUX   0)
    set(PLATFORM_GNU     0)
    set(PLATFORM_MACOSX  0)
    set(PLATFORM_OTHER   1)

    # Platform-dependent implementation of system.h
    set(SYSTEM_CPP_MODULE "system_other.cpp")
    set(SYSTEM_H_MODULE "system_other.h")
endif()


##
# Build options
##

# Build targets should be placed in the root build directory
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

# Include cmake directory with some additional scripts
set(CMAKE_MODULE_PATH "${colobot_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})

# Compiler detection
if(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
    if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4.7)
        message(FATAL_ERROR "${PROJECT_NAME} requires GCC 4.7 or greater.")
    endif()

    message(STATUS "Detected GCC version 4.7+")

    set(NORMAL_CXX_FLAGS "-std=gnu++11 -Wall -Wold-style-cast")
    set(RELEASE_CXX_FLAGS "-O2")
    set(DEBUG_CXX_FLAGS "-g -O0")
    set(TEST_CXX_FLAGS "-pthread")
    add_definitions(-DNOEXCEPT=noexcept -DHAVE_DEMANGLE)
elseif(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 3.1)
        message(FATAL_ERROR "${PROJECT_NAME} requires Clang 3.1 or greater.")
    endif()

    message(STATUS "Detected Clang version 3.1+")

    set(NORMAL_CXX_FLAGS "-std=c++11 -Wall -Wold-style-cast")
    set(RELEASE_CXX_FLAGS "-O2")
    set(DEBUG_CXX_FLAGS "-g -O0")
    set(TEST_CXX_FLAGS "-pthread")
    add_definitions(-DNOEXCEPT=noexcept -DHAVE_DEMANGLE)
elseif(CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
    message(STATUS "Detected MSVC compiler")

    set(NORMAL_CXX_FLAGS "/wd\"4244\" /wd\"4309\" /wd\"4800\" /wd\"4996\" /wd\"4351\"") # disable some useless warnings
    set(RELEASE_CXX_FLAGS "")
    set(DEBUG_CXX_FLAGS "")
    set(TEST_CXX_FLAGS "")
    add_definitions(-DNOEXCEPT= -DHAS_MSVC_EXCEPTION_BUG)
else()
    message(FATAL_ERROR "Your C++ compiler doesn't seem to be supported.")
endif()


# Global compile flags
# These are specific to GCC/MinGW/clang; for other compilers, change as necessary
# The flags are used throughout src/ and test/ subdirs

# Special flags for boost
add_definitions(-DBOOST_NO_SCOPED_ENUMS -DBOOST_NO_CXX11_SCOPED_ENUMS)

set(COLOBOT_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${NORMAL_CXX_FLAGS}")
set(COLOBOT_CXX_FLAGS_RELEASE "${RELEASE_CXX_FLAGS}")
set(COLOBOT_CXX_FLAGS_DEBUG "${DEBUG_CXX_FLAGS}")

# Flags for gtest
set(COLOBOT_GTEST_CXX_FLAGS "${TEST_CXX_FLAGS}")


# Asserts can be enabled/disabled regardless of build type
option(ASSERTS "Enable assert()s" ON)

# Development build can be enabled/disabled regardless of build type
option(DEV_BUILD "Enable development build (enables some debugging tools, local setting paths, etc.)" OFF)

# Official build - changes text on the crash screen
# PLEASE DO NOT USE ON UNOFFICIAL BUILDS. Thanks.
option(OFFICIAL_BUILD "Official build (changes crash screen text)" OFF)

# Portable build - load all data from current directory
option(PORTABLE "Portable build" OFF)

# Building tests can be enabled/disabled
option(TESTS "Build tests" OFF)

# Building tool programs can be enabled/disabled
option(TOOLS "Build tool programs" OFF)

# CBot can also be a static library
option(CBOT_STATIC "Build CBot as static libary" OFF)

# Generate desktop files, manpage, etc.
option(DESKTOP "Generate desktop files, manpages, etc" ON)

# Doxygen docs are optional for installation
option(INSTALL_DOCS "Install Doxygen-generated documentation" OFF)

# Build OpenAL sound support
option(OPENAL_SOUND "Build OpenAL sound support" ON)

# This is useful in case you want to use static boost libraries
option(BOOST_STATIC "Link with static boost libraries" OFF)

# This is useful on Windows, if linking against standard GLEW dll fails
option(GLEW_STATIC "Link statically with GLEW" OFF)

# Sometimes helpful if there is a different version of gtest installed on system vs bundled
option(FORCE_BUNDLED_GTEST "Force the use of bundled gtest" OFF)

# This is for use with colobot-lint tool
option(COLOBOT_LINT_BUILD "Generate some additional CMake targets for use with colobot-lint" OFF)


# Default build type if not given is debug
if(NOT CMAKE_BUILD_TYPE)
    message(STATUS "Build type not specified - assuming debug")
    set(CMAKE_BUILD_TYPE Debug CACHE STRING "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif()

# Warn about development build
if(DEV_BUILD)
    message(STATUS "Building with development extensions")
endif()


##
# Searching for packages
##

find_package(OpenGL 1.4 REQUIRED)
find_package(SDL2 REQUIRED)
find_package(SDL2_image REQUIRED)
find_package(SDL2_ttf REQUIRED)
find_package(PNG 1.2 REQUIRED)
find_package(Gettext REQUIRED)
find_package(PhysFS REQUIRED)

set(Boost_USE_STATIC_LIBS ${BOOST_STATIC})
set(Boost_USE_MULTITHREADED ON)
set(Boost_USE_STATIC_RUNTIME OFF)

set(Boost_ADDITIONALVERSION "1.51" "1.51.0")
find_package(Boost COMPONENTS system filesystem regex REQUIRED)

find_package(GLEW REQUIRED)

if (OPENAL_SOUND)
    find_package(OpenAL REQUIRED)
    include_directories(${OPENAL_INCLUDE_DIR})
    find_package(LibSndFile REQUIRED)
endif()


if(NOT ASSERTS)
    add_definitions(-DNDEBUG)
endif()

if(TESTS)
    add_definitions(-DTESTS -DTEST_VIRTUAL=virtual)
else()
    add_definitions(-DTEST_VIRTUAL=)
endif()

if(DEV_BUILD)
    add_definitions(-DDEV_BUILD)
endif()

##
# Additional settings to use when cross-compiling with MXE (http://mxe.cc/)
##

include("${colobot_SOURCE_DIR}/cmake/mxe.cmake")

##
# Additional settings for MSYS
##
include("${colobot_SOURCE_DIR}/cmake/msys.cmake")

##
# Additional functions for colobot-lint
##
include("${colobot_SOURCE_DIR}/cmake/colobot-lint.cmake")


##
# MSVC specific settings
##
set(WINGETOPT 0)
if(CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
    message(STATUS "Adding MSVC-specific options")

    set(CBOT_STATIC 1) # only this works for some reason
    set(WINGETOPT 1) # use wingetopt library
endif()

##
# Localename
##
set(LOCALENAME_INCLUDE_DIR ${colobot_SOURCE_DIR}/lib/localename)
add_subdirectory(lib/localename)


##
# Wingetopt
##
if(WINGETOPT)
    set(WINGETOPT_INCLUDE_DIR ${colobot_SOURCE_DIR}/lib/wingetopt/src)
    add_subdirectory(lib/wingetopt)
endif()


##
# Doxygen docs
##

find_package(Doxygen)

if(DOXYGEN_FOUND AND DOXYGEN_DOT_FOUND)
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
    add_custom_target(doc
                      ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
                      WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
                      COMMENT "Generating API documentation with Doxygen" VERBATIM)
endif()


##
# Targets
##

# Installation paths defined before compiling sources
if(PLATFORM_WINDOWS)
    if(MXE)
        # We need to use STRING because PATH doesn't accept relative paths
        set(COLOBOT_INSTALL_BIN_DIR ./ CACHE STRING "Colobot binary directory")
        set(COLOBOT_INSTALL_LIB_DIR ./ CACHE STRING "Colobot libraries directory")
        set(COLOBOT_INSTALL_DATA_DIR ./data CACHE STRING "Colobot shared data directory")
        set(COLOBOT_INSTALL_I18N_DIR ./lang CACHE STRING "Colobot translations directory")
        set(COLOBOT_INSTALL_DOC_DIR ./doc CACHE STRING "Colobot documentation directory")
    else()
        set(COLOBOT_INSTALL_BIN_DIR ${CMAKE_INSTALL_PREFIX}/ CACHE PATH "Colobot binary directory")
        set(COLOBOT_INSTALL_LIB_DIR ${CMAKE_INSTALL_PREFIX}/ CACHE PATH "Colobot libraries directory")
        set(COLOBOT_INSTALL_DATA_DIR ${CMAKE_INSTALL_PREFIX}/data CACHE PATH "Colobot shared data directory")
        set(COLOBOT_INSTALL_I18N_DIR ${CMAKE_INSTALL_PREFIX}/lang CACHE PATH "Colobot translations directory")
        set(COLOBOT_INSTALL_DOC_DIR ${CMAKE_INSTALL_PREFIX}/doc CACHE PATH "Colobot documentation directory")
    endif()
elseif(PLATFORM_MACOSX)
    set(COLOBOT_INSTALL_BIN_DIR ../MacOS CACHE STRING "Colobot binary directory")
    set(COLOBOT_INSTALL_LIB_DIR ../MacOS CACHE STRING "Colobot libraries directory")
    set(COLOBOT_INSTALL_DATA_DIR . CACHE STRING "Colobot shared data directory")
    set(COLOBOT_INSTALL_I18N_DIR i18n CACHE SRING "Colobot translations directory")
    set(COLOBOT_INSTALL_DOC_DIR doc CACHE STRING "Colobot documentation directory")
else()

=== src/CMakeLists.txt ===
# Compile flags as defined in global CMakeLists
set(CMAKE_CXX_FLAGS "${COLOBOT_CXX_FLAGS} ${MXE_CFLAGS}")
set(CMAKE_CXX_FLAGS_RELEASE ${COLOBOT_CXX_FLAGS_RELEASE})
set(CMAKE_CXX_FLAGS_DEBUG ${COLOBOT_CXX_FLAGS_DEBUG})

# Groups source files for IDE project
macro(group_sources SOURCES GROUP_ROOT)
    foreach(SOURCE_FILE ${SOURCES})
        get_filename_component(GROUP "${SOURCE_FILE}" PATH)
        string(REPLACE "/" "\\" GROUP "${GROUP}")
        set(GROUP "${GROUP_ROOT}\\${GROUP}")
        source_group("${GROUP}" FILES "${SOURCE_FILE}")
    endforeach()
endmacro()

# Subdirectories

add_subdirectory(CBot)

if(TOOLS)
    add_subdirectory(tools)
endif()

add_subdirectory(graphics/opengl/shaders)


# Optional libraries
set(OPTIONAL_LIBS "")
set(OPTIONAL_INCLUDES "")

if(OPENAL_SOUND)
    set(OPTIONAL_LIBS ${OPENAL_LIBRARY})
    set(OPTIONAL_INCLUDES ${OPENAL_INCLUDE_DIR})
endif()

if(WINGETOPT)
    set(OPTIONAL_LIBS ${OPTIONAL_LIBS} wingetopt)
    set(OPTIONAL_INCLUDES ${OPTIONAL_INCLUDES} ${WINGETOPT_INCLUDE_DIR})
endif()

# Additional libraries per platform
if(MXE) # MXE requires special treatment
    set(PLATFORM_LIBS ${MXE_LIBS})
elseif(PLATFORM_WINDOWS)
    # because it isn't included in standard linking libraries
    if(CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
        find_library(LIBINTL_LIBRARY NAMES intl.lib)
        set(PLATFORM_LIBS ${LIBINTL_LIBRARY})
    else()
        set(PLATFORM_LIBS "-lintl")
    endif()
elseif(PLATFORM_GNU)
    set(PLATFORM_LIBS "")
elseif(PLATFORM_LINUX)
    # for clock_gettime
    set(PLATFORM_LIBS "-lrt")
elseif(PLATFORM_MACOSX)
    find_library(LIBINTL_LIBRARY NAMES intl libintl)
    find_path(LIBINTL_INCLUDE_PATH NAMES libintl.h)
    set(PLATFORM_LIBS ${LIBINTL_LIBRARY})
endif()


# Configure file
configure_file(common/config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/common/config.h)
configure_file(common/version.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/common/version.h)

set(OPENAL_SRC "")

if(OPENAL_SOUND)
    set(OPENAL_SRC
        sound/oalsound/alsound.cpp
        sound/oalsound/buffer.cpp
        sound/oalsound/channel.cpp
        sound/oalsound/check.cpp
        sound/oalsound/alsound.h
        sound/oalsound/buffer.h
        sound/oalsound/channel.h
        sound/oalsound/check.h
    )
endif()

set(RES_FILES "")

if(PLATFORM_WINDOWS)
    set(RES_FILES "../desktop/colobot.rc")
endif()

# Source files
set(BASE_SOURCES
    ${OPENAL_SRC}
    app/${SYSTEM_CPP_MODULE}
    app/${SYSTEM_H_MODULE}
    app/app.cpp
    app/app.h
    app/controller.cpp
    app/controller.h
    app/input.cpp
    app/input.h
    app/pathman.cpp
    app/pathman.h
    app/pausemanager.cpp
    app/pausemanager.h
    app/signal_handlers.cpp
    app/signal_handlers.h
    app/system.cpp
    app/system.h
    app/system_other.cpp
    app/system_other.h
    common/config_file.cpp
    common/config_file.h
    common/error.h
    common/event.cpp
    common/event.h
    common/global.h
    common/image.cpp
    common/image.h
    common/ioutils.h
    common/key.cpp
    common/key.h
    common/language.cpp
    common/language.h
    common/logger.cpp
    common/logger.h
    common/make_unique.h
    common/regex_utils.cpp
    common/regex_utils.h
    common/resources/inputstream.cpp
    common/resources/inputstream.h
    common/resources/inputstreambuffer.cpp
    common/resources/inputstreambuffer.h
    common/resources/outputstream.cpp
    common/resources/outputstream.h
    common/resources/outputstreambuffer.cpp
    common/resources/outputstreambuffer.h
    common/resources/resourcemanager.cpp
    common/resources/resourcemanager.h
    common/resources/sdl_file_wrapper.cpp
    common/resources/sdl_file_wrapper.h
    common/resources/sdl_memory_wrapper.cpp
    common/resources/sdl_memory_wrapper.h
    common/resources/sndfile_wrapper.cpp
    common/resources/sndfile_wrapper.h
    common/restext.cpp
    common/restext.h
    common/settings.cpp
    common/settings.h
    common/singleton.h
    common/stringutils.cpp
    common/stringutils.h
    common/thread/resource_owning_thread.h
    common/thread/sdl_cond_wrapper.h
    common/thread/sdl_mutex_wrapper.h
    graphics/core/color.cpp
    graphics/core/color.h
    graphics/core/device.h
    graphics/core/framebuffer.cpp
    graphics/core/framebuffer.h
    graphics/core/light.h
    graphics/core/material.h
    graphics/core/nulldevice.cpp
    graphics/core/nulldevice.h
    graphics/core/texture.h
    graphics/core/vertex.h
    graphics/engine/camera.cpp
    graphics/engine/camera.h
    graphics/engine/cloud.cpp
    graphics/engine/cloud.h
    graphics/engine/engine.cpp
    graphics/engine/engine.h
    graphics/engine/lightman.cpp
    graphics/engine/lightman.h
    graphics/engine/lightning.cpp
    graphics/engine/lightning.h
    graphics/engine/oldmodelmanager.cpp
    graphics/engine/oldmodelmanager.h
    graphics/engine/particle.cpp
    graphics/engine/particle.h
    graphics/engine/planet.cpp
    graphics/engine/planet.h
    graphics/engine/pyro.cpp
    graphics/engine/pyro.h
    graphics/engine/pyro_manager.cpp
    graphics/engine/pyro_manager.h
    graphics/engine/pyro_type.h
    graphics/engine/terrain.cpp
    graphics/engine/terrain.h
    graphics/engine/text.cpp
    graphics/engine/text.h
    graphics/engine/water.cpp
    graphics/engine/water.h
    graphics/model/model.cpp
    graphics/model/model.h
    graphics/model/model_crash_sphere.h
    graphics/model/model_format.h
    graphics/model/model_input.cpp
    graphics/model/model_input.h
    graphics/model/model_io_exception.h
    graphics/model/model_io_structs.h
    graphics/model/model_manager.cpp
    graphics/model/model_manager.h
    graphics/model/model_mesh.cpp
    graphics/model/model_mesh.h
    graphics/model/model_output.cpp
    graphics/model/model_output.h
    graphics/model/model_shadow_spot.h
    graphics/model/model_triangle.h
    graphics/opengl/gl14device.cpp
    graphics/opengl/gl14device.h
    graphics/opengl/gl21device.cpp
    graphics/opengl/gl21device.h
    graphics/opengl/gl33device.cpp
    graphics/opengl/gl33device.h
    graphics/opengl/glframebuffer.cpp
    graphics/opengl/glframebuffer.h
    graphics/opengl/glutil.cpp
    graphics/opengl/glutil.h
    level/build_type.h
    level/level_category.cpp
    level/level_category.h
    level/mainmovie.cpp
    level/mainmovie.h
    level/parser/parser.cpp
    level/parser/parser.h
    level/parser/parserexceptions.cpp
    level/parser/parserexceptions.h
    level/parser/parserline.cpp
    level/parser/parserline.h
    level/parser/parserparam.cpp
    level/parser/parserparam.h
    level/player_profile.cpp
    level/player_profile.h
    level/research_type.h
    level/robotmain.cpp
    level/robotmain.h
    level/scene_conditions.cpp
    level/scene_conditions.h
    math/all.h
    math/const.h
    math/func.h
    math/geometry.h
    math/intpoint.h
    math/matrix.h
    math/point.h
    math/sphere.h
    math/vector.h
    object/auto/auto.cpp
    object/auto/auto.h
    object/auto/autobase.cpp
    object/auto/autobase.h
    object/auto/autoconvert.cpp
    object/auto/autoconvert.h
    object/auto/autoderrick.cpp
    object/auto/autoderrick.h
    object/auto/autodestroyer.cpp
    object/auto/autodestroyer.h
    object/auto/autoegg.cpp
    object/auto/autoegg.h
    object/auto/autofactory.cpp
    object/auto/autofactory.h
    object/auto/autoflag.cpp
    object/auto/autoflag.h
    object/auto/autohouston.cpp
    object/auto/autohouston.h
    object/auto/autojostle.cpp
    object/auto/autojostle.h
    object/auto/autokid.cpp
    object/auto/autokid.h
    object/auto/autolabo.cpp
    object/auto/autolabo.h
    object/auto/automush.cpp
    object/auto/automush.h
    object/auto/autonest.cpp
    object/auto/autonest.h
    object/auto/autonuclearplant.cpp
    object/auto/autonuclearplant.h
    object/auto/autoportico.cpp
    object/auto/autoportico.h
    object/auto/autopowercaptor.cpp
    object/auto/autopowercaptor.h
    object/auto/autopowerplant.cpp
    object/auto/autopowerplant.h
    object/auto/autopowerstation.cpp
    object/auto/autopowerstation.h
    object/auto/autoradar.cpp
    object/auto/autoradar.h
    object/auto/autorepair.cpp
    object/auto/autorepair.h
    object/auto/autoresearch.cpp
    object/auto/autoresearch.h
    object/auto/autoroot.cpp
    object/auto/autoroot.h
    object/auto/autotower.cpp
    object/auto/autotower.h
    object/auto/autovault.cpp
    object/auto/autovault.h
    object/crash_sphere.h
    object/drive_type.cpp
    object/drive_type.h
    object/implementation/power_container_impl.cpp
    object/implementation/power_container_impl.h
    object/implementation/program_storage_impl.cpp
    object/implementation/program_storage_impl.h
    object/implementation/programmable_impl.cpp
    object/implementation/programmable_impl.h
    object/implementation/task_executor_impl.cpp
    object/implementation/task_executor_impl.h
    object/interface/carrier_object.h
    object/interface/controllable_object.h
    object/interface/damageable_object.h
    object/interface/destroyable_object.h
    object/interface/flying_object.h
    object/interface/fragile_object.h
    object/interface/interactive_object.h
    object/interface/jet_flying_object.h
    object/interface/jostleable_object.h
    object/interface/movable_object.h
    object/interface/power_container_object.h
    object/interface/powered_object.h
    object/interface/program_storage_object.h
    object/interface/programmable_object.h
    object/interface/ranged_object.h
    object/interface/shielded_auto_regen_object.h
    object/interface/shielded_object.h
    object/interface/task_executor_object.h
    object/interface/trace_drawing_object.cpp
    object/interface/trace_drawing_object.h
    object/interface/transportable_object.h
    object/mission_type.h
    object/motion/motion.cpp
    object/motion/motion.h
    object/motion/motionant.cpp
    object/motion/motionant.h
    object/motion/motionbee.cpp
    object/motion/motionbee.h
    object/motion/motionhuman.cpp
    object/motion/motionhuman.h
    object/motion/motionlevelcontroller.cpp
    object/motion/motionlevelcontroller.h
    object/motion/motionqueen.cpp
    object/motion/motionqueen.h
    object/motion/motionspider.cpp
    object/motion/motionspider.h
    object/motion/motiontoto.cpp
    object/motion/motiontoto.h
    object/motion/motionvehicle.cpp
    object/motion/motionvehicle.h
    object/motion/motionworm.cpp
    object/motion/motionworm.h
    object/object.cpp
    object/object.h
    object/object_create_exception.h
    object/object_create_params.h
    object/object_factory.cpp
    object/object_factory.h
    object/object_interface_type.h
    object/object_manager.cpp
    object/object_manager.h
    object/object_type.h
    object/old_object.cpp
    object/old_object.h
    object/old_object_interface.cpp
    object/old_object_interface.h
    object/subclass/base_alien.cpp
    object/subclass/base_alien.h
    object/subclass/base_building.cpp
    object/subclass/base_building.h
    object/subclass/base_robot.cpp
    object/subclass/base_robot.h
    object/subclass/base_vehicle.cpp
    object/subclass/base_vehicle.h
    object/subclass/exchange_post.cpp
    object/subclass/exchange_post.h
    object/subclass/shielder.cpp
    object/subclass/shielder.h
    object/subclass/static_object.cpp
    object/subclass/static_object.h
    object/task/task.cpp
    object/task/task.h
    object/task/taskadvance.cpp
    object/task/taskadvance.h
    object/task/taskbuild.cpp
    object/task/taskbuild.h
    object/task/taskdeletemark.cpp
    object/task/taskdeletemark.h
    object/task/taskfire.cpp
    object/task/taskfire.h
    object/task/taskfireant.cpp
    object/task/taskfireant.h
    object/task/taskflag.cpp
    object/task/taskflag.h
    object/task/taskgoto.cpp
    object/task/taskgoto.h
    object/task/taskgungoal.cpp
    object/task/taskgungoal.h
    object/task/taskinfo.cpp
    object/task/taskinfo.h
    object/task/taskmanip.cpp
    object/task/taskmanip.h

=== src/CBot/CMakeLists.txt ===
set(SOURCES
    CBot.h
    CBotCStack.cpp
    CBotCStack.h
    CBotCallMethode.cpp
    CBotCallMethode.h
    CBotClass.cpp
    CBotClass.h
    CBotDebug.cpp
    CBotDebug.h
    CBotDefParam.cpp
    CBotDefParam.h
    CBotDefines.h
    CBotEnums.h
    CBotExternalCall.cpp
    CBotExternalCall.h
    CBotFileUtils.cpp
    CBotFileUtils.h
    CBotInstr/CBotBlock.cpp
    CBotInstr/CBotBlock.h
    CBotInstr/CBotBoolExpr.cpp
    CBotInstr/CBotBoolExpr.h
    CBotInstr/CBotBreak.cpp
    CBotInstr/CBotBreak.h
    CBotInstr/CBotCase.cpp
    CBotInstr/CBotCase.h
    CBotInstr/CBotCatch.cpp
    CBotInstr/CBotCatch.h
    CBotInstr/CBotCondition.cpp
    CBotInstr/CBotCondition.h
    CBotInstr/CBotDefArray.cpp
    CBotInstr/CBotDefArray.h
    CBotInstr/CBotDefBoolean.cpp
    CBotInstr/CBotDefBoolean.h
    CBotInstr/CBotDefClass.cpp
    CBotInstr/CBotDefClass.h
    CBotInstr/CBotDefFloat.cpp
    CBotInstr/CBotDefFloat.h
    CBotInstr/CBotDefInt.cpp
    CBotInstr/CBotDefInt.h
    CBotInstr/CBotDefString.cpp
    CBotInstr/CBotDefString.h
    CBotInstr/CBotDo.cpp
    CBotInstr/CBotDo.h
    CBotInstr/CBotEmpty.cpp
    CBotInstr/CBotEmpty.h
    CBotInstr/CBotExprLitBool.cpp
    CBotInstr/CBotExprLitBool.h
    CBotInstr/CBotExprLitNan.cpp
    CBotInstr/CBotExprLitNan.h
    CBotInstr/CBotExprLitNull.cpp
    CBotInstr/CBotExprLitNull.h
    CBotInstr/CBotExprLitNum.cpp
    CBotInstr/CBotExprLitNum.h
    CBotInstr/CBotExprLitString.cpp
    CBotInstr/CBotExprLitString.h
    CBotInstr/CBotExprUnaire.cpp
    CBotInstr/CBotExprUnaire.h
    CBotInstr/CBotExprVar.cpp
    CBotInstr/CBotExprVar.h
    CBotInstr/CBotExpression.cpp
    CBotInstr/CBotExpression.h
    CBotInstr/CBotFieldExpr.cpp
    CBotInstr/CBotFieldExpr.h
    CBotInstr/CBotFor.cpp
    CBotInstr/CBotFor.h
    CBotInstr/CBotFunction.cpp
    CBotInstr/CBotFunction.h
    CBotInstr/CBotIf.cpp
    CBotInstr/CBotIf.h
    CBotInstr/CBotIndexExpr.cpp
    CBotInstr/CBotIndexExpr.h
    CBotInstr/CBotInstr.cpp
    CBotInstr/CBotInstr.h
    CBotInstr/CBotInstrCall.cpp
    CBotInstr/CBotInstrCall.h
    CBotInstr/CBotInstrMethode.cpp
    CBotInstr/CBotInstrMethode.h
    CBotInstr/CBotInstrUtils.cpp
    CBotInstr/CBotInstrUtils.h
    CBotInstr/CBotLeftExpr.cpp
    CBotInstr/CBotLeftExpr.h
    CBotInstr/CBotLeftExprVar.cpp
    CBotInstr/CBotLeftExprVar.h
    CBotInstr/CBotListArray.cpp
    CBotInstr/CBotListArray.h
    CBotInstr/CBotListExpression.cpp
    CBotInstr/CBotListExpression.h
    CBotInstr/CBotListInstr.cpp
    CBotInstr/CBotListInstr.h
    CBotInstr/CBotLogicExpr.cpp
    CBotInstr/CBotLogicExpr.h
    CBotInstr/CBotNew.cpp
    CBotInstr/CBotNew.h
    CBotInstr/CBotParExpr.cpp
    CBotInstr/CBotParExpr.h
    CBotInstr/CBotPostIncExpr.cpp
    CBotInstr/CBotPostIncExpr.h
    CBotInstr/CBotPreIncExpr.cpp
    CBotInstr/CBotPreIncExpr.h
    CBotInstr/CBotReturn.cpp
    CBotInstr/CBotReturn.h
    CBotInstr/CBotSwitch.cpp
    CBotInstr/CBotSwitch.h
    CBotInstr/CBotThrow.cpp
    CBotInstr/CBotThrow.h
    CBotInstr/CBotTry.cpp
    CBotInstr/CBotTry.h
    CBotInstr/CBotTwoOpExpr.cpp
    CBotInstr/CBotTwoOpExpr.h
    CBotInstr/CBotWhile.cpp
    CBotInstr/CBotWhile.h
    CBotProgram.cpp
    CBotProgram.h
    CBotStack.cpp
    CBotStack.h
    CBotToken.cpp
    CBotToken.h
    CBotTypResult.cpp
    CBotTypResult.h
    CBotUtils.cpp
    CBotUtils.h
    CBotVar/CBotVar.cpp
    CBotVar/CBotVar.h
    CBotVar/CBotVarValue.h
    CBotVar/CBotVarArray.cpp
    CBotVar/CBotVarArray.h
    CBotVar/CBotVarBoolean.cpp
    CBotVar/CBotVarBoolean.h
    CBotVar/CBotVarClass.cpp
    CBotVar/CBotVarClass.h
    CBotVar/CBotVarFloat.cpp
    CBotVar/CBotVarFloat.h
    CBotVar/CBotVarInt.cpp
    CBotVar/CBotVarInt.h
    CBotVar/CBotVarPointer.cpp
    CBotVar/CBotVarPointer.h
    CBotVar/CBotVarString.cpp
    CBotVar/CBotVarString.h
    stdlib/Compilation.cpp
    stdlib/Compilation.h
    stdlib/FileFunctions.cpp
    stdlib/MathFunctions.cpp
    stdlib/StringFunctions.cpp
    stdlib/stdlib.h
    stdlib/stdlib_public.h
)

# Includes
set(LOCAL_INCLUDES
    ${CMAKE_CURRENT_SOURCE_DIR}/..
)

include_directories(${LOCAL_INCLUDES})


if(CBOT_STATIC)
    add_library(CBot STATIC ${SOURCES})
else()
    add_library(CBot SHARED ${SOURCES})
    install(TARGETS CBot LIBRARY
            DESTINATION ${COLOBOT_INSTALL_LIB_DIR}
            ARCHIVE DESTINATION ${COLOBOT_INSTALL_LIB_DIR}
            RUNTIME DESTINATION ${COLOBOT_INSTALL_BIN_DIR})
endif()

group_sources("${SOURCES}" "Source Files")

=== test/unit/CMakeLists.txt ===
# Platform-dependent tests
if(PLATFORM_WINDOWS)
    set(PLATFORM_TESTS app/system_windows_test.cpp)
elseif(PLATFORM_LINUX)
    set(PLATFORM_TESTS app/system_linux_test.cpp)
endif()

# Sources
set(UT_SOURCES
    main.cpp
    app/app_test.cpp
    CBot/CBotToken_test.cpp
    CBot/CBot_test.cpp
    common/config_file_test.cpp
    graphics/engine/lightman_test.cpp
    math/func_test.cpp
    math/geometry_test.cpp
    math/matrix_test.cpp
    math/vector_test.cpp
    ${PLATFORM_TESTS}
)

# Includes
include_directories(
    common
    math
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${COLOBOT_LOCAL_INCLUDES}
)

include_directories(
    SYSTEM
    ${GTEST_INCLUDE_DIR}
    ${HIPPOMOCKS_INCLUDE_DIR}
    ${COLOBOT_SYSTEM_INCLUDES}
)

# Libraries
set(LIBS
    gtest
    colobotbase
    ${COLOBOT_LIBS}
)

# Test files

set(TEST_FILES
    common/colobot.ini
)

file(COPY ${TEST_FILES} DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})

# Targets

add_definitions(-DGTEST_HAS_TR1_TUPLE=0)

add_executable(colobot_ut ${UT_SOURCES})
target_link_libraries(colobot_ut ${LIBS})

add_test(
    NAME colobot_ut
    COMMAND ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/colobot_ut
    WORKING_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
)

=== debian/changelog ===
colobot (0.1.8-2build2) zesty; urgency=high

  * No change rebuild against boost1.62.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 01 Nov 2016 16:14:14 +0000

colobot (0.1.8-2build1) yakkety; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 04 Aug 2016 08:15:27 +0000

colobot (0.1.8-2) unstable; urgency=medium

  * Move xmlstarlet from B-D-I to B-D; fixes arch-only FTBFS

 -- Didier Raboud <odyx@debian.org>  Mon, 11 Jul 2016 20:12:04 +0200

colobot (0.1.8-1) unstable; urgency=medium

  * New upstream release: 0.1.8

  * Bump S-V to 3.9.8 without changes needed
  * Add xmlstarlet as B-D needed for the new SVG resizing code

 -- Didier Raboud <odyx@debian.org>  Mon, 11 Jul 2016 10:39:08 +0200

=== debian/control ===
Source: colobot
Section: games
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Didier Raboud <odyx@debian.org>
Build-Depends:
 cmake,
 debhelper (>= 9.20151219~),
 google-mock,
 imagemagick,
 libboost-dev,
 libboost-filesystem-dev,
 libboost-regex-dev,
 libboost-system-dev,
 libgl1-mesa-dev | libgl-dev,
 libglew-dev,
 libgtest-dev,
 libopenal-dev,
 libpng-dev,
 libphysfs-dev,
 librsvg2-bin,
 libsdl2-image-dev,
 libsdl2-ttf-dev,
 libsdl2-dev,
 libsndfile-dev,
 perl,
 po4a,
 xmlstarlet,
Build-Depends-Indep:
 doxygen,
 graphviz,
 vorbis-tools,
Vcs-Git: https://alioth.debian.org/anonscm/git/pkg-games/colobot.git -b debian
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-games/colobot.git
Standards-Version: 3.9.8
Homepage: http://colobot.info

Package: colobot
Architecture: any
Depends:
 colobot-common (>= ${source:Version}),
 colobot-common-sounds (>= ${source:Version}),
 colobot-common-textures (>= ${source:Version}),
 fonts-dejavu-core,
 fonts-dejavu-extra,
 ${misc:Depends},
 ${shlibs:Depends}
Replaces:
 colobot-common (<< 0.1.1-2)
Breaks:
 colobot-common (<< 0.1.1-2)
Description: educational programming strategy game
 Colobot (Colonize with Bots) is an educational game aiming to teach
 programming through entertainment. You are playing as an astronaut on a
 journey with robot helpers to find a planet for colonization. It features 3D
 real-time graphics and a C++ and Java-like, object-oriented language, CBOT,
 which can be used to program the robots available in the game.

Package: colobot-common
Architecture: all
Depends:
 ${misc:Depends}
Recommends:
 colobot (>= ${source:Version})
Description: educational programming strategy game - data
 Colobot (Colonize with Bots) is an educational game aiming to teach
 programming through entertainment. You are playing as an astronaut on a
 journey with robot helpers to find a planet for colonization. It features 3D
 real-time graphics and a C++ and Java-like, object-oriented language, CBOT,
 which can be used to program the robots available in the game.
 .
 This package contains the architecture-independent game data.

Package: colobot-common-textures
Architecture: all
Depends:
 ${misc:Depends}
Recommends:
 colobot (>= ${source:Version})
Replaces:
 colobot-common (<< 0.1.1-2)
Breaks:
 colobot-common (<< 0.1.1-2)
Description: educational programming strategy game - textures
 Colobot (Colonize with Bots) is an educational game aiming to teach
 programming through entertainment. You are playing as an astronaut on a
 journey with robot helpers to find a planet for colonization. It features 3D
 real-time graphics and a C++ and Java-like, object-oriented language, CBOT,
 which can be used to program the robots available in the game.
 .
 This package contains the textures for the game.

Package: colobot-common-sounds
Architecture: all
Depends:
 ${misc:Depends}
Recommends:
 colobot (>= ${source:Version})
Replaces:
 colobot-common (<< 0.1.1-2)
Breaks:
 colobot-common (<< 0.1.1-2)
Description: educational programming strategy game - sounds and music
 Colobot (Colonize with Bots) is an educational game aiming to teach
 programming through entertainment. You are playing as an astronaut on a
 journey with robot helpers to find a planet for colonization. It features 3D
 real-time graphics and a C++ and Java-like, object-oriented language, CBOT,
 which can be used to program the robots available in the game.
 .
 This package contains the sounds and music for the game.

Package: colobot-dev-doc
Architecture: all
Section: doc
Depends:
 libjs-jquery,
 ${misc:Depends}
Recommends:
 colobot (>= ${source:Version})
Description: educational programming strategy game - source doc
 Colobot (Colonize with Bots) is an educational game aiming to teach
 programming through entertainment. You are playing as an astronaut on a
 journey with robot helpers to find a planet for colonization. It features 3D
 real-time graphics and a C++ and Java-like, object-oriented language, CBOT,
 which can be used to program the robots available in the game.
 .
 This package contains the doxygen documentation for the colobot source code.

## colobot 0.1.9

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,7 +13,7 @@
 set(COLOBOT_VERSION_CODENAME "Gold")
 set(COLOBOT_VERSION_MAJOR    0)
 set(COLOBOT_VERSION_MINOR    1)
-set(COLOBOT_VERSION_REVISION 8)
+set(COLOBOT_VERSION_REVISION 9)
 
 # Used on official releases
 set(COLOBOT_VERSION_RELEASE_CODENAME "-alpha")
@@ -132,7 +132,8 @@
 
     message(STATUS "Detected GCC version 4.7+")
 
-    set(NORMAL_CXX_FLAGS "-std=gnu++11 -Wall -Wold-style-cast")
+    set(NORMAL_CXX_FLAGS "-std=gnu++11 -Wall -Wold-style-cast -pedantic-errors")
+    set(NORMAL_CXX_FLAGS "${NORMAL_CXX_FLAGS} -fno-delete-null-pointer-checks") # Temporary hack, see #828
     set(RELEASE_CXX_FLAGS "-O2")
     set(DEBUG_CXX_FLAGS "-g -O0")
     set(TEST_CXX_FLAGS "-pthread")
@@ -144,7 +145,7 @@
 
     message(STATUS "Detected Clang version 3.1+")
 
-    set(NORMAL_CXX_FLAGS "-std=c++11 -Wall -Wold-style-cast")
+    set(NORMAL_CXX_FLAGS "-std=c++11 -Wall -Wold-style-cast -pedantic-errors")
     set(RELEASE_CXX_FLAGS "-O2")
     set(DEBUG_CXX_FLAGS "-g -O0")
     set(TEST_CXX_FLAGS "-pthread")
@@ -152,11 +153,15 @@
 elseif(CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
     message(STATUS "Detected MSVC compiler")
 
-    set(NORMAL_CXX_FLAGS "/wd\"4244\" /wd\"4309\" /wd\"4800\" /wd\"4996\" /wd\"4351\"") # disable some useless warnings
-    set(RELEASE_CXX_FLAGS "")
-    set(DEBUG_CXX_FLAGS "")
+    set(NORMAL_CXX_FLAGS "/wd\"4244\" /wd\"4309\" /wd\"4800\" /wd\"4996\" /wd\"4351\" /EHsc") # disable some useless warnings
+    set(RELEASE_CXX_FLAGS "/MD")
+    set(DEBUG_CXX_FLAGS "/MDd /ZI")
     set(TEST_CXX_FLAGS "")
     add_definitions(-DNOEXCEPT= -DHAS_MSVC_EXCEPTION_BUG)
+
+    # Needed for Debug information (it's set to "No" by default for some reason)
+    set(CMAKE_EXE_LINKER_FLAGS_DEBUG "/DEBUG")
+    set(CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO "/DEBUG")
 else()
     message(FATAL_ERROR "Your C++ compiler doesn't seem to be supported.")
 endif()
@@ -356,8 +361,3 @@
     endif()
 elseif(PLATFORM_MACOSX)
     set(COLOBOT_INSTALL_BIN_DIR ../MacOS CACHE STRING "Colobot binary directory")
-    set(COLOBOT_INSTALL_LIB_DIR ../MacOS CACHE STRING "Colobot libraries directory")
-    set(COLOBOT_INSTALL_DATA_DIR . CACHE STRING "Colobot shared data directory")
-    set(COLOBOT_INSTALL_I18N_DIR i18n CACHE SRING "Colobot translations directory")
-    set(COLOBOT_INSTALL_DOC_DIR doc CACHE STRING "Colobot documentation directory")
-else()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -89,8 +89,6 @@
 # Source files
 set(BASE_SOURCES
     ${OPENAL_SRC}
-    app/${SYSTEM_CPP_MODULE}
-    app/${SYSTEM_H_MODULE}
     app/app.cpp
     app/app.h
     app/controller.cpp
@@ -103,10 +101,6 @@
     app/pausemanager.h
     app/signal_handlers.cpp
     app/signal_handlers.h
-    app/system.cpp
-    app/system.h
-    app/system_other.cpp
-    app/system_other.h
     common/config_file.cpp
     common/config_file.h
     common/error.h
@@ -123,6 +117,8 @@
     common/logger.cpp
     common/logger.h
     common/make_unique.h
+    common/profiler.cpp
+    common/profiler.h
     common/regex_utils.cpp
     common/regex_utils.h
     common/resources/inputstream.cpp
@@ -143,6 +139,12 @@
     common/resources/sndfile_wrapper.h
     common/restext.cpp
     common/restext.h
+    common/system/system.cpp
+    common/system/system.h
+    common/system/system_other.cpp
+    common/system/system_other.h
+    common/system/${SYSTEM_CPP_MODULE}
+    common/system/${SYSTEM_H_MODULE}
     common/settings.cpp
     common/settings.h
     common/singleton.h
@@ -151,6 +153,8 @@
     common/thread/resource_owning_thread.h
     common/thread/sdl_cond_wrapper.h
     common/thread/sdl_mutex_wrapper.h
+    common/thread/thread.h
+    common/thread/worker_thread.h
     graphics/core/color.cpp
     graphics/core/color.h
     graphics/core/device.h
@@ -391,9 +395,3 @@
     object/task/taskflag.h
     object/task/taskgoto.cpp
     object/task/taskgoto.h
-    object/task/taskgungoal.cpp
-    object/task/taskgungoal.h
-    object/task/taskinfo.cpp
-    object/task/taskinfo.h
-    object/task/taskmanip.cpp
-    object/task/taskmanip.h

=== src/CBot/CMakeLists.txt ===
--- 
+++ 
@@ -54,6 +54,8 @@
     CBotInstr/CBotExprLitNum.h
     CBotInstr/CBotExprLitString.cpp
     CBotInstr/CBotExprLitString.h
+    CBotInstr/CBotExprRetVar.cpp
+    CBotInstr/CBotExprRetVar.h
     CBotInstr/CBotExprUnaire.cpp
     CBotInstr/CBotExprUnaire.h
     CBotInstr/CBotExprVar.cpp

=== debian/changelog ===
colobot (0.1.9-5) unstable; urgency=medium

  * Add patch to find the available level translations with a sorted
    os.listdir, to avoid picking unreproducibilty from the directory files
    order

 -- Didier Raboud <odyx@debian.org>  Sat, 17 Dec 2016 14:10:44 +0100

colobot (0.1.9-4) unstable; urgency=medium

  * Update oggenc-reproducibility patch to use the original file's bytesize as
    --serial integer (Closes: #846976)

 -- Didier Raboud <odyx@debian.org>  Mon, 05 Dec 2016 13:35:48 +0100

colobot (0.1.9-3) unstable; urgency=medium

  * Revert "Patch hippomocks to broaden its architecture support"
  * Allow tests to fail on architectures without support in hippomocks,
    circumvent the FTBFS

 -- Didier Raboud <odyx@debian.org>  Tue, 08 Nov 2016 20:36:37 +0100

colobot (0.1.9-2) unstable; urgency=medium

  * Patch hippomocks to broaden its architecture support.
    This should fix the mips* and arm64 FTBFS'es.
    Thanks-to: Philippe Coval <philippe.coval@osg.samsung.com>

 -- Didier Raboud <odyx@debian.org>  Mon, 07 Nov 2016 08:37:19 +0100

colobot (0.1.9-1) unstable; urgency=medium

  * New upstream release: 0.1.9

  * Build and run unit tests
  * Set the 'Official Build' flag
  * Make all arch:all packages Multi-Arch: foreign
  * Reproducibility patches:
    - Patch the flac-to-ogg conversion to use the filename as ogg serial number
    - Patch the Doxygen configuration to avoid embedding the build path in the
      documentation

 -- Didier Raboud <odyx@debian.org>  Fri, 04 Nov 2016 12:04:36 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: colobot
 Section: games
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
+Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders:
  Didier Raboud <odyx@debian.org>
 Build-Depends:
@@ -60,6 +59,7 @@
 
 Package: colobot-common
 Architecture: all
+Multi-Arch: foreign
 Depends:
  ${misc:Depends}
 Recommends:
@@ -75,6 +75,7 @@
 
 Package: colobot-common-textures
 Architecture: all
+Multi-Arch: foreign
 Depends:
  ${misc:Depends}
 Recommends:
@@ -94,6 +95,7 @@
 
 Package: colobot-common-sounds
 Architecture: all
+Multi-Arch: foreign
 Depends:
  ${misc:Depends}
 Recommends:
@@ -113,6 +115,7 @@
 
 Package: colobot-dev-doc
 Architecture: all
+Multi-Arch: foreign
 Section: doc
 Depends:
  libjs-jquery,

## colobot 0.1.10

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,7 +13,7 @@
 set(COLOBOT_VERSION_CODENAME "Gold")
 set(COLOBOT_VERSION_MAJOR    0)
 set(COLOBOT_VERSION_MINOR    1)
-set(COLOBOT_VERSION_REVISION 9)
+set(COLOBOT_VERSION_REVISION 10)
 
 # Used on official releases
 set(COLOBOT_VERSION_RELEASE_CODENAME "-alpha")
@@ -132,8 +132,8 @@
 
     message(STATUS "Detected GCC version 4.7+")
 
-    set(NORMAL_CXX_FLAGS "-std=gnu++11 -Wall -Wold-style-cast -pedantic-errors")
-    set(NORMAL_CXX_FLAGS "${NORMAL_CXX_FLAGS} -fno-delete-null-pointer-checks") # Temporary hack, see #828
+    set(NORMAL_CXX_FLAGS "-std=gnu++11 -Wall -Werror -Wold-style-cast -pedantic-errors")
+    set(NORMAL_CXX_FLAGS "${NORMAL_CXX_FLAGS} -Wno-error=deprecated-declarations") # updated version of physfs is not available on some platforms so we keep using deprecated functions, see #958
     set(RELEASE_CXX_FLAGS "-O2")
     set(DEBUG_CXX_FLAGS "-g -O0")
     set(TEST_CXX_FLAGS "-pthread")
@@ -145,7 +145,8 @@
 
     message(STATUS "Detected Clang version 3.1+")
 
-    set(NORMAL_CXX_FLAGS "-std=c++11 -Wall -Wold-style-cast -pedantic-errors")
+    set(NORMAL_CXX_FLAGS "-std=c++11 -Wall -Werror -Wold-style-cast -pedantic-errors")
+    set(NORMAL_CXX_FLAGS "${NORMAL_CXX_FLAGS} -Wno-error=deprecated-declarations") # updated version of physfs is not available on some platforms so we keep using deprecated functions, see #958
     set(RELEASE_CXX_FLAGS "-O2")
     set(DEBUG_CXX_FLAGS "-g -O0")
     set(TEST_CXX_FLAGS "-pthread")
@@ -356,8 +357,3 @@
         set(COLOBOT_INSTALL_BIN_DIR ${CMAKE_INSTALL_PREFIX}/ CACHE PATH "Colobot binary directory")
         set(COLOBOT_INSTALL_LIB_DIR ${CMAKE_INSTALL_PREFIX}/ CACHE PATH "Colobot libraries directory")
         set(COLOBOT_INSTALL_DATA_DIR ${CMAKE_INSTALL_PREFIX}/data CACHE PATH "Colobot shared data directory")
-        set(COLOBOT_INSTALL_I18N_DIR ${CMAKE_INSTALL_PREFIX}/lang CACHE PATH "Colobot translations directory")
-        set(COLOBOT_INSTALL_DOC_DIR ${CMAKE_INSTALL_PREFIX}/doc CACHE PATH "Colobot documentation directory")
-    endif()
-elseif(PLATFORM_MACOSX)
-    set(COLOBOT_INSTALL_BIN_DIR ../MacOS CACHE STRING "Colobot binary directory")

=== debian/changelog ===
colobot (0.1.10-2build1) bionic; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 26 Oct 2017 17:12:41 +0000

colobot (0.1.10-2) unstable; urgency=medium

  * Migrate 0.1.10 to unstable
  * Bump Standards-Version to 4.0.0 without changes needed
  * Migrate to debhelper compat 10

 -- Didier Raboud <odyx@debian.org>  Sun, 23 Jul 2017 11:27:51 +0200

colobot (0.1.10-1) experimental; urgency=low

  * New upstream release: 0.1.10

 -- Didier Raboud <odyx@debian.org>  Tue, 30 May 2017 16:37:44 +0200

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
  Didier Raboud <odyx@debian.org>
 Build-Depends:
  cmake,
- debhelper (>= 9.20151219~),
+ debhelper (>= 10.2.5~),
  google-mock,
  imagemagick,
  libboost-dev,
@@ -33,7 +33,7 @@
  vorbis-tools,
 Vcs-Git: https://alioth.debian.org/anonscm/git/pkg-games/colobot.git -b debian
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-games/colobot.git
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Homepage: http://colobot.info
 
 Package: colobot

=== debian/rules ===
#!/usr/bin/make -f

HIPPOMOCKS_BROKEN_ARCHS=arm64 mips mips64el mipsel
DEB_HOST_ARCH:=$(shell dpkg-architecture -qDEB_HOST_ARCH)

CBOT_CONFIGURE_SOUNDS=-DMUSIC:BOOL=False
ifneq (,$(findstring colobot-common-sounds, $(shell dh_listpackages)))
CBOT_CONFIGURE_SOUNDS=-DMUSIC:BOOL=True -DMUSIC_FLAC:BOOL=True
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_TYPE:STRING="RelWithDebInfo" \
	                     -DOFFICIAL_BUILD:BOOL=True \
	                     -DTESTS:BOOL=True \
	                     -DINSTALL_DOCS:BOOL=True \
	                     ${CBOT_CONFIGURE_SOUNDS} \
	                     -DOPENAL_SOUND:BOOL=True -DCMAKE_VERBOSE_MAKEFILE=True

override_dh_auto_build-arch:
	dh_auto_build -a
	# obj-* is the default builddirectory in debhelper
	convert obj-$(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)/desktop/32/colobot.png debian/colobot.xpm

override_dh_auto_build-indep:
	dh_auto_build -i -- doc

ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(HIPPOMOCKS_BROKEN_ARCHS)))
override_dh_auto_test-arch:
	# Allow the tests to fail on that architecture, see #843690
	- dh_auto_test -a
endif

override_dh_auto_test-indep:

override_dh_auto_clean:
	dh_auto_clean
	rm -f debian/colobot.xpm

# can be removed after stretch have been released
override_dh_strip:
	dh_strip --ddeb-migration='colobot-dbg (<< 0.1.6-3~)'
